@ECHO OFF

REM // make sure we can write to the file KEHNetplay.bin
REM // also make a backup to KEHNetplay.prev.bin
IF NOT EXIST KEHNetplay.bin goto LABLNOCOPY
IF EXIST KEHNetplay.prev.bin del KEHNetplay.prev.bin
IF EXIST KEHNetplay.prev.bin goto LABLNOCOPY
move /Y KEHNetplay.bin KEHNetplay.prev.bin
IF EXIST KEHNetplay.bin goto LABLERROR3
REM IF EXIST KEHNetplay.prev.bin copy /Y KEHNetplay.prev.bin KEHNetplay.bin
:LABLNOCOPY

REM // delete some intermediate assembler output just in case
IF EXIST s2.p del s2.p
IF EXIST s2.p goto LABLERROR2

REM // clear the output window
cls

REM // run the assembler
REM // -xx shows the most detailed error output
REM // -c outputs a shared file (s2.h)
REM // -A gives us a small speedup
set AS_MSGPATH=win32/msg
set USEANSI=n

REM // allow the user to choose to print error messages out by supplying the -pe parameter
"win32/asw" -xx -E -A -L -r 2 -q -U -D Netplay=1 s2.asm

REM // if there were errors, a log file is produced
IF EXIST s2.log goto LABLERROR4
REM // combine the assembler output into a rom
IF EXIST s2.p "win32/s2p2bin_plus" s2.p KEHNetplay.bin


REM // done -- pause if we seem to have failed, then exit
IF NOT EXIST s2.p goto LABLPAUSE
del s2.p
:LABLPAUSE

pause


exit /b

:LABLERROR2
echo Failed to build because write access to s2.p was denied.
pause


exit /b

:LABLERROR3
echo Failed to build because write access to KEHNetplay.bin was denied.
pause

exit /b

:LABLERROR4
REM // display a noticeable message
echo.
echo **********************************************************************
echo *                                                                    *
echo *   There were build errors/warnings. See s2.log for more details.   *
echo *                                                                    *
echo **********************************************************************
echo.
pause


